<template>
    <Dialog :title="dialogTitle" v-model="dialogVisible">
        <el-form
            ref="formRef"
            :model="formData"
            label-width="80px"
            v-loading="formLoading"
        >
            <el-form-item label="快递公司" prop="deliverInfo.name" :rules="[{ required: true, message: '快递公司不能为空', trigger: 'blur' }]">
                <el-input v-model="formData.deliverInfo.name" placeholder="请输入快递公司" />
            </el-form-item>
            <el-form-item label="快递单号" prop="deliverInfo.no" :rules="[{ required: true, message: '快递单号不能为空', trigger: 'blur' }]">
                <el-input v-model="formData.deliverInfo.no" placeholder="请输入快递单号" />
            </el-form-item>
            <el-form-item label="备注" prop="deliverInfo.remark">
                <el-input v-model="formData.deliverInfo.remark" placeholder="请输入备注" />
            </el-form-item>
        </el-form>
        <template #footer>
          <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
          <el-button @click="dialogVisible = false">取 消</el-button>
        </template>
    </Dialog>
</template>

<script setup lang="ts">
import { LuckLotteryRecordApi, LuckLotteryRecordVO } from '@/api/mall/promotion/lottery/record'
          
/** 幸运抽奖-抽奖记录 表单 */
defineOptions({ name: 'LuckLotteryRecordForm' })
const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
    id: undefined,
    userId: undefined,
    lotteryId: undefined,
    prizeId: undefined,
    type: undefined,
    isReceive: undefined,
    receiveTime: undefined,
    receiveInfo: undefined,
    isDeliver: undefined,
    deliverTime: undefined,
    deliverInfo: {
        no: undefined,
        name: undefined,
        remark: undefined
    }
})
const formRef = ref() // 表单 Ref
          
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
    dialogVisible.value = true
    dialogTitle.value = t('action.' + type)
    formType.value = type
    resetForm()
    // 修改时，设置数据
    if (id) {
        formLoading.value = true
        try {
            const data = await LuckLotteryRecordApi.getLuckLotteryRecord(id)
            formData.value = data
            if (!data.deliverInfo || !Object.keys(data.deliverInfo).length) {
                formData.value.deliverInfo = {
                    no: undefined,
                    name: undefined,
                    remark: undefined
                }
            } else formData.value.deliverInfo = JSON.parse(data.deliverInfo)
        } finally {
            formLoading.value = false
        }
    }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗
/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
    // 校验表单
    await formRef.value.validate()
    // 提交请求
    formLoading.value = true
    try {
        const data = formData.value as unknown as LuckLotteryRecordVO
        data.deliverInfo = JSON.stringify(data.deliverInfo)
        if (formType.value === 'create') {
            await LuckLotteryRecordApi.createLuckLotteryRecord(data)
            message.success(t('common.createSuccess'))
        } else {
            await LuckLotteryRecordApi.updateLuckLotteryRecord(data)
            message.success(t('common.updateSuccess'))
        }
        dialogVisible.value = false
        // 发送操作成功的事件
        emit('success')
    } finally {
        formLoading.value = false
    }
}
/** 重置表单 */
const resetForm = () => {
    formData.value = {
        id: undefined,
        userId: undefined,
        lotteryId: undefined,
        prizeId: undefined,
        type: undefined,
        isReceive: undefined,
        receiveTime: undefined,
        receiveInfo: undefined,
        isDeliver: undefined,
        deliverTime: undefined,
        deliverInfo: {
            name: undefined,
            no: undefined,
            remark: undefined
        }
    }
    formRef.value?.resetFields()
}
</script>